function InMemoryCache() {
    this.allowEmptyState = true;
    this.tokens = [];
    this.clients = [{
        clientId: 'ed',
        clientSecret: 'zeedhi',
        redirectUris: ['http://localhost:3000/callback'],
        grants: ['authorization_code', 'password'],
    }];
    this.users = [
       { id: '1', username: 'zeedhi@teknisa.com', password: 'zeedhi' }
    ];

    /*
     * Get access token.
     */
    this.getAccessToken = (bearerToken) => {
        var tokens = this.tokens.filter((token) => {
            return token.accessToken === bearerToken;
        });
        return tokens.length ? tokens[0] : false;
    };

    /**
    * Get refresh token.
    */
    this.getRefreshToken = (bearerToken) => {
        var tokens = this.tokens.filter((token) => {
            return token.refreshToken === bearerToken;
        });
        return tokens.length ? tokens[0] : false;
    };

    /**
    * Get client.
    */
    this.getClient = (clientId, clientSecret) => {
        var clients = this.clients.filter((client) => {
            return client.clientId === clientId;
        });
        return clients.length ? clients[0] : false;
    };

    /**
    * Save token.
    */
    this.saveToken = (token, client, user) => {
        let savedToken = {
            accessToken: token.accessToken,
            accessTokenExpiresAt: token.accessTokenExpiresAt,
            clientId: client.clientId,
            refreshToken: token.refreshToken,
            refreshTokenExpiresAt: token.refreshTokenExpiresAt,
            userId: user.id
        };
        this.tokens.push(savedToken);
        delete savedToken.clientId;
        delete savedToken.userId;
        savedToken.user = user;
        savedToken.client = client;
        return savedToken;
    };

    /*
    * Get user.
    */
    this.getUser = (username, password) => {
        var users = this.users.filter((user) => {
            return user.username === username && user.password === password;
        });
        return users.length ? users[0] : false;
    };
}

/**
* Export constructor.
*/
module.exports = InMemoryCache;